#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>
ordered_set;

const int N = (int) 1e5 + 10;

int add[4 * N], t[4 * N];

void push(int v, int l, int r) {
    if (add[v] == 0) return;
    t[v] = add[v] * (r - l + 1);
    if (l != r)
        add[v * 2] = add[v], add[v * 2 + 1] = add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl)
        return;
    if (l >= tl && r <= tr) {
        add[v] = val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val);
    update(v * 2 + 1, mid + 1, r, tl, tr, val);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get_sum(int v, int l, int r, int tl, int tr) {
    push(v, l, r);
    if (l > tr || r < tl)
        return 0;
    if (l >= tl && r <= tr)
        return t[v];
    int mid = (l + r) / 2;
    return get_sum(v * 2, l, mid, tl, tr) + get_sum(v * 2 + 1, mid + 1, r, tl, tr);
}

const int H = 20;
int st[H][N], pos[H][N], a[N], n;

void init() {
    for (int i = 0; i < n; i++) st[0][i] = a[i], pos[0][i] = i;
    for (int lg = 1; lg < H; lg++)
        for (int i = 0; i + (1 << lg) <= n; i++) {
            st[lg][i] = max(st[lg - 1][i], st[lg - 1][i + (1 << (lg - 1))]);
            if (st[lg][i] == st[lg - 1][i]) pos[lg][i] = pos[lg - 1][i];
            else pos[lg][i] = pos[lg - 1][i + (1 << (lg - 1))];
        }
}

int get_max(int l, int r) {
    int lg = __lg(r - l + 1);
    if (st[lg][l] > st[lg][r - (1 << lg) + 1])
        return pos[lg][l];
    return pos[lg][r - (1 << lg) + 1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    init();
    int p[n];
    for (int i = 0; i < n; i++) p[i] = a[i] + (i > 0 ? p[i - 1] : 0);
    for (int i = 0; i < n; i++) {
        update(1, 0, n - 1, i, i, a[i]);
    }
    ordered_set seg;
    for (int i = 0; i < n; i++) seg.insert({i, i});
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        auto seg1 = *seg.find_by_order(k - 1),
                seg2 = *seg.find_by_order(k);
        int l1 = seg1.first, r1 = seg1.second;
        int l2 = seg2.first, r2 = seg2.second;
        int p1 = get_max(l1, r1), p2 = get_max(l2, r2);
        if (a[p1] <= a[p2]) {
            update(1, 0, n - 1, p1, r1, a[p1]);
        } else {
            int l = p1, r = r1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (a[get_max(mid, r1)] >= a[p2]) l = mid;
                else r = mid;
            }
            int ind = -1;
            if (a[get_max(l, r1)] < a[p2]) ind = l;
            else if (a[get_max(r, r1)] < a[p2]) ind = r;
            if (ind != -1)
                update(1, 0, n - 1, ind, r1, a[p2]);
        }
        if (a[p1] >= a[p2]) {
            update(1, 0, n - 1, l2, p2, a[p2]);
        } else {
            int l = l2, r = p2;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (a[get_max(l2, mid)] >= a[p1]) r = mid;
                else l = mid;
            }
            int ind = -1;
            if (a[get_max(l2, r)] < a[p1]) ind = r;
            else if (a[get_max(l2, l)] < a[p1]) ind = l;
            if (ind != -1)
                update(1, 0, n - 1, l2, ind, a[p1]);
        }
        seg.erase({l1, r1});
        seg.erase({l2, r2});
        seg.insert({l1, r2});
        cout << get_sum(1, 0, n - 1, l1, r2) - (p[r2] - (l1 > 0 ? p[l1 - 1] : 0)) << "\n";
    }
    return 0;
}
